<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="锁仓周期:" prop="period">
          <el-input v-model.number="formData.period" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="amount字段:" prop="amount">
          <el-input v-model.number="formData.amount" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="startTime字段:" prop="startTime">
          <el-date-picker v-model="formData.startTime" type="date" placeholder="选择日期" :clearable="true"></el-date-picker>
        </el-form-item>
        <el-form-item label="0 后台提交 1 上链 2 上链成功质押中 3 上链失败 4 申请解压 5 已解压:" prop="status">
          <el-select v-model="formData.status" placeholder="请选择" :clearable="true">
            <el-option v-for="(item,key) in brc_lock_statusOptions" :key="key" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="addr字段:" prop="addr">
          <el-input v-model="formData.addr" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="lockAddr字段:" prop="lockAddr">
          <el-input v-model="formData.lockAddr" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="hash字段:" prop="hash">
          <el-input v-model="formData.hash" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="unsignTx字段:" prop="unsignTx">
          <el-input v-model="formData.unsignTx" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'BrcLock'
}
</script>

<script setup>
import {
  createBrcLock,
  updateBrcLock,
  findBrcLock
} from '@/api/brcLock'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const brc_lock_statusOptions = ref([])
const formData = ref({
            period: 0,
            amount: 0,
            startTime: new Date(),
            status: undefined,
            addr: '',
            lockAddr: '',
            hash: '',
            unsignTx: '',
        })
// 验证规则
const rule = reactive({
               period : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               amount : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               startTime : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               addr : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               lockAddr : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findBrcLock({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.rebrcLock
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
    brc_lock_statusOptions.value = await getDictFunc('brc_lock_status')
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createBrcLock(formData.value)
               break
             case 'update':
               res = await updateBrcLock(formData.value)
               break
             default:
               res = await createBrcLock(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
